<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>UsbInterface Class Reference</title>
<link href="xsens.css" rel="stylesheet" type="text/css"/>
</head><body>
<img class="logo" src="xsenslogo.jpg" alt="Xsens Logo" />
	<!-- Generated by Doxygen 1.8.11 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="class_usb_interface-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">UsbInterface Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>An <a class="el" href="struct_io_interface.html" title="An abstract IO interface. ">IoInterface</a> for dealing specifically with Xsens USB devices.  
 <a href="class_usb_interface.html#details">More...</a></p>
<div class="dynheader">
Inheritance diagram for UsbInterface:</div>
<div class="dyncontent">
<div class="center"><img src="class_usb_interface__inherit__graph.png" border="0" usemap="#_usb_interface_inherit__map" alt="Inheritance graph"/></div>
<map name="_usb_interface_inherit__map" id="_usb_interface_inherit__map">
<area shape="rect" id="node2" href="class_stream_interface.html" title="A stream interface. " alt="" coords="5,80,117,107"/>
<area shape="rect" id="node3" href="struct_io_interface.html" title="An abstract IO interface. " alt="" coords="21,5,101,32"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ac07f3faa766905efc0b7e5a49e17821f"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac07f3faa766905efc0b7e5a49e17821f"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_usb_interface.html#ac07f3faa766905efc0b7e5a49e17821f">UsbInterface</a> ()</td></tr>
<tr class="memdesc:ac07f3faa766905efc0b7e5a49e17821f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default constructor, initializes all members to their default values. <br /></td></tr>
<tr class="separator:ac07f3faa766905efc0b7e5a49e17821f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad8ebf84e48b3c841f4d47932e5602772"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad8ebf84e48b3c841f4d47932e5602772"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_usb_interface.html#ad8ebf84e48b3c841f4d47932e5602772">~UsbInterface</a> ()</td></tr>
<tr class="memdesc:ad8ebf84e48b3c841f4d47932e5602772"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor, de-initializes, frees memory allocated for buffers, etc. <br /></td></tr>
<tr class="separator:ad8ebf84e48b3c841f4d47932e5602772"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a730125b63bdd3662ce18834b948982db"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a730125b63bdd3662ce18834b948982db"></a>
<a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_usb_interface.html#a730125b63bdd3662ce18834b948982db">open</a> (const <a class="el" href="struct_xs_port_info.html">XsPortInfo</a> &amp;portInfo, uint32_t readBufSize=0, uint32_t writeBufSize=0, <a class="el" href="struct_io_interface.html#a24230835a198e4af06866402ac41f22a">PortOptions</a>=PO_XsensDefaults)</td></tr>
<tr class="memdesc:a730125b63bdd3662ce18834b948982db"><td class="mdescLeft">&#160;</td><td class="mdescRight">Open a communication channel to the given USB port name. <br /></td></tr>
<tr class="separator:a730125b63bdd3662ce18834b948982db"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2f54092dbcd40b305db8dadf2c94fa61"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2f54092dbcd40b305db8dadf2c94fa61"></a>
<a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_usb_interface.html#a2f54092dbcd40b305db8dadf2c94fa61">close</a> (void)</td></tr>
<tr class="memdesc:a2f54092dbcd40b305db8dadf2c94fa61"><td class="mdescLeft">&#160;</td><td class="mdescRight">Close the USB communication port. <br /></td></tr>
<tr class="separator:a2f54092dbcd40b305db8dadf2c94fa61"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a86e9d5e41cb861313dfcc234b0909190"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_usb_interface.html#a86e9d5e41cb861313dfcc234b0909190">closeUsb</a> (void)</td></tr>
<tr class="memdesc:a86e9d5e41cb861313dfcc234b0909190"><td class="mdescLeft">&#160;</td><td class="mdescRight">Close the USB communication port.  <a href="#a86e9d5e41cb861313dfcc234b0909190">More...</a><br /></td></tr>
<tr class="separator:a86e9d5e41cb861313dfcc234b0909190"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaf61c58b150bbf94cfe8c98768a7444a"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_usb_interface.html#aaf61c58b150bbf94cfe8c98768a7444a">flushData</a> (void)</td></tr>
<tr class="memdesc:aaf61c58b150bbf94cfe8c98768a7444a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flush all data in the buffers to and from the device.  <a href="#aaf61c58b150bbf94cfe8c98768a7444a">More...</a><br /></td></tr>
<tr class="separator:aaf61c58b150bbf94cfe8c98768a7444a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a512b02ac9f133d31cfa179734ac8c16b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a512b02ac9f133d31cfa179734ac8c16b"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_usb_interface.html#a512b02ac9f133d31cfa179734ac8c16b">isOpen</a> (void) const </td></tr>
<tr class="memdesc:a512b02ac9f133d31cfa179734ac8c16b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return whether the USB communication port is open or not. <br /></td></tr>
<tr class="separator:a512b02ac9f133d31cfa179734ac8c16b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a093c68850798716354499bf861844562"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a093c68850798716354499bf861844562"></a>
uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_usb_interface.html#a093c68850798716354499bf861844562">usbBus</a> () const </td></tr>
<tr class="memdesc:a093c68850798716354499bf861844562"><td class="mdescLeft">&#160;</td><td class="mdescRight">The USB bus number this device is on (libusb/linux only) <br /></td></tr>
<tr class="separator:a093c68850798716354499bf861844562"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2bd11d81c91b67933ee71e097137dd53"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2bd11d81c91b67933ee71e097137dd53"></a>
uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_usb_interface.html#a2bd11d81c91b67933ee71e097137dd53">usbAddress</a> () const </td></tr>
<tr class="memdesc:a2bd11d81c91b67933ee71e097137dd53"><td class="mdescLeft">&#160;</td><td class="mdescRight">The address of the device (libusb/linux only) <br /></td></tr>
<tr class="separator:a2bd11d81c91b67933ee71e097137dd53"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a400f9078d319698483422bcfec55e65d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a400f9078d319698483422bcfec55e65d"></a>
<a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_usb_interface.html#a400f9078d319698483422bcfec55e65d">getLastResult</a> (void) const </td></tr>
<tr class="memdesc:a400f9078d319698483422bcfec55e65d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the error code of the last operation. <br /></td></tr>
<tr class="separator:a400f9078d319698483422bcfec55e65d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a78570ffcef7534e52d3f303a800a1acd"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_usb_interface.html#a78570ffcef7534e52d3f303a800a1acd">setTimeout</a> (uint32_t ms)</td></tr>
<tr class="memdesc:a78570ffcef7534e52d3f303a800a1acd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the default timeout value to use in blocking operations.  <a href="#a78570ffcef7534e52d3f303a800a1acd">More...</a><br /></td></tr>
<tr class="separator:a78570ffcef7534e52d3f303a800a1acd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a272526477ecb1a148f414a9c1656beac"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a272526477ecb1a148f414a9c1656beac"></a>
uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_usb_interface.html#a272526477ecb1a148f414a9c1656beac">getTimeout</a> (void) const </td></tr>
<tr class="memdesc:a272526477ecb1a148f414a9c1656beac"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the current timeout value. <br /></td></tr>
<tr class="separator:a272526477ecb1a148f414a9c1656beac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaa01d7bd28d4d7d2772097b2c86fd063"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_usb_interface.html#aaa01d7bd28d4d7d2772097b2c86fd063">setRawIo</a> (bool enable)</td></tr>
<tr class="memdesc:aaa01d7bd28d4d7d2772097b2c86fd063"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the RAWIO mode of the USB interface.  <a href="#aaa01d7bd28d4d7d2772097b2c86fd063">More...</a><br /></td></tr>
<tr class="separator:aaa01d7bd28d4d7d2772097b2c86fd063"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af99af474c041ab9b517b76655b7b608c"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_usb_interface.html#af99af474c041ab9b517b76655b7b608c">getRawIo</a> (void)</td></tr>
<tr class="memdesc:af99af474c041ab9b517b76655b7b608c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieves the state of the RAWIO mode of the USB interface.  <a href="#af99af474c041ab9b517b76655b7b608c">More...</a><br /></td></tr>
<tr class="separator:af99af474c041ab9b517b76655b7b608c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a305123c46c8c06e6d715d3e8e9bdc7b4"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_usb_interface.html#a305123c46c8c06e6d715d3e8e9bdc7b4">writeData</a> (const <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;data, XsSize *written=NULL)</td></tr>
<tr class="memdesc:a305123c46c8c06e6d715d3e8e9bdc7b4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the data to the USB port.  <a href="#a305123c46c8c06e6d715d3e8e9bdc7b4">More...</a><br /></td></tr>
<tr class="separator:a305123c46c8c06e6d715d3e8e9bdc7b4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6c6113f7c73248ff95524ce3d784b39d"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_usb_interface.html#a6c6113f7c73248ff95524ce3d784b39d">readData</a> (XsSize maxLength, <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;data)</td></tr>
<tr class="memdesc:a6c6113f7c73248ff95524ce3d784b39d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read data from the USB port and put it into the data buffer.  <a href="#a6c6113f7c73248ff95524ce3d784b39d">More...</a><br /></td></tr>
<tr class="separator:a6c6113f7c73248ff95524ce3d784b39d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aef40c902045c8bc9ec0d2f0d7145b4a6"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_usb_interface.html#aef40c902045c8bc9ec0d2f0d7145b4a6">writeData</a> (XsSize length, const void *data, XsSize *written=NULL)</td></tr>
<tr class="memdesc:aef40c902045c8bc9ec0d2f0d7145b4a6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the data to the USB port.  <a href="#aef40c902045c8bc9ec0d2f0d7145b4a6">More...</a><br /></td></tr>
<tr class="separator:aef40c902045c8bc9ec0d2f0d7145b4a6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa532baddc5650010517434e37d61bae1"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_usb_interface.html#aa532baddc5650010517434e37d61bae1">readData</a> (XsSize maxLength, void *data, XsSize *length=NULL)</td></tr>
<tr class="memdesc:aa532baddc5650010517434e37d61bae1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read data from the serial port and put it into the data buffer.  <a href="#aa532baddc5650010517434e37d61bae1">More...</a><br /></td></tr>
<tr class="separator:aa532baddc5650010517434e37d61bae1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad86f450f4f49c9d4dcb9ecc3e3fb425a"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_usb_interface.html#ad86f450f4f49c9d4dcb9ecc3e3fb425a">waitForData</a> (XsSize maxLength, void *data, XsSize *length=NULL)</td></tr>
<tr class="memdesc:ad86f450f4f49c9d4dcb9ecc3e3fb425a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Wait for data to arrive or a timeout to occur.  <a href="#ad86f450f4f49c9d4dcb9ecc3e3fb425a">More...</a><br /></td></tr>
<tr class="separator:ad86f450f4f49c9d4dcb9ecc3e3fb425a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac00b6232a58670484307232c9c79a6db"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac00b6232a58670484307232c9c79a6db"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_usb_interface.html#ac00b6232a58670484307232c9c79a6db">getPortName</a> (<a class="el" href="struct_xs_string.html">XsString</a> &amp;portname) const </td></tr>
<tr class="memdesc:ac00b6232a58670484307232c9c79a6db"><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieve the port name that was last successfully opened. <br /></td></tr>
<tr class="separator:ac00b6232a58670484307232c9c79a6db"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_class_stream_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_class_stream_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="class_stream_interface.html">StreamInterface</a></td></tr>
<tr class="memitem:a747b4b4bc61925c6750ee35a54de30c5 inherit pub_methods_class_stream_interface"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a747b4b4bc61925c6750ee35a54de30c5"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_stream_interface.html#a747b4b4bc61925c6750ee35a54de30c5">~StreamInterface</a> ()</td></tr>
<tr class="memdesc:a747b4b4bc61925c6750ee35a54de30c5 inherit pub_methods_class_stream_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destroy the stream interface. <br /></td></tr>
<tr class="separator:a747b4b4bc61925c6750ee35a54de30c5 inherit pub_methods_class_stream_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_struct_io_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_struct_io_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="struct_io_interface.html">IoInterface</a></td></tr>
<tr class="memitem:a738a8cb24aa12562b04c5067bd3d99b7 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a738a8cb24aa12562b04c5067bd3d99b7"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a738a8cb24aa12562b04c5067bd3d99b7">~IoInterface</a> ()</td></tr>
<tr class="memdesc:a738a8cb24aa12562b04c5067bd3d99b7 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor. <br /></td></tr>
<tr class="separator:a738a8cb24aa12562b04c5067bd3d99b7 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa9763f4a8ea90af8abeab4ada6f36502 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#aa9763f4a8ea90af8abeab4ada6f36502">waitForData</a> (XsSize maxLength, <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;data)</td></tr>
<tr class="memdesc:aa9763f4a8ea90af8abeab4ada6f36502 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Wait for data to arrive or a timeout to occur.  <a href="#aa9763f4a8ea90af8abeab4ada6f36502">More...</a><br /></td></tr>
<tr class="separator:aa9763f4a8ea90af8abeab4ada6f36502 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a030b6c12d92276a494fc926e578ada79 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a030b6c12d92276a494fc926e578ada79">cancelIo</a> (void) const </td></tr>
<tr class="memdesc:a030b6c12d92276a494fc926e578ada79 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Cancel any pending io requests.  <a href="#a030b6c12d92276a494fc926e578ada79">More...</a><br /></td></tr>
<tr class="separator:a030b6c12d92276a494fc926e578ada79 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae4f4b165b49c75cb28bc1e4fffaf533d inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#ae4f4b165b49c75cb28bc1e4fffaf533d">appendData</a> (const <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;bdata)</td></tr>
<tr class="memdesc:ae4f4b165b49c75cb28bc1e4fffaf533d inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write data to the end of the file.  <a href="#ae4f4b165b49c75cb28bc1e4fffaf533d">More...</a><br /></td></tr>
<tr class="separator:ae4f4b165b49c75cb28bc1e4fffaf533d inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a108ea51f7057bc5f762052777e7baa00 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a108ea51f7057bc5f762052777e7baa00">closeAndDelete</a> (void)</td></tr>
<tr class="memdesc:a108ea51f7057bc5f762052777e7baa00 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Close the file and delete it.  <a href="#a108ea51f7057bc5f762052777e7baa00">More...</a><br /></td></tr>
<tr class="separator:a108ea51f7057bc5f762052777e7baa00 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3e82060ef66d73b95b383f75867f3e0f inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a3e82060ef66d73b95b383f75867f3e0f">create</a> (const <a class="el" href="struct_xs_string.html">XsString</a> &amp;filename)</td></tr>
<tr class="memdesc:a3e82060ef66d73b95b383f75867f3e0f inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create an empty file.  <a href="#a3e82060ef66d73b95b383f75867f3e0f">More...</a><br /></td></tr>
<tr class="separator:a3e82060ef66d73b95b383f75867f3e0f inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5c4a40c13cdd1dbd36da1323f8d8236c inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a5c4a40c13cdd1dbd36da1323f8d8236c">deleteData</a> (<a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a> start, XsSize length)</td></tr>
<tr class="memdesc:a5c4a40c13cdd1dbd36da1323f8d8236c inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Delete the given data from the file.  <a href="#a5c4a40c13cdd1dbd36da1323f8d8236c">More...</a><br /></td></tr>
<tr class="separator:a5c4a40c13cdd1dbd36da1323f8d8236c inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6256ce5c2def7b6f6961cedd8199e35e inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a6256ce5c2def7b6f6961cedd8199e35e">find</a> (const <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;needleV, <a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a> &amp;pos)</td></tr>
<tr class="memdesc:a6256ce5c2def7b6f6961cedd8199e35e inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Find a string of bytes in the file.  <a href="#a6256ce5c2def7b6f6961cedd8199e35e">More...</a><br /></td></tr>
<tr class="separator:a6256ce5c2def7b6f6961cedd8199e35e inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af7acf94e2070b556290d969a324e8b93 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#af7acf94e2070b556290d969a324e8b93">getFileSize</a> (void) const </td></tr>
<tr class="memdesc:af7acf94e2070b556290d969a324e8b93 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the size of the file.  <a href="#af7acf94e2070b556290d969a324e8b93">More...</a><br /></td></tr>
<tr class="separator:af7acf94e2070b556290d969a324e8b93 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7bbdfbb5caad826f6e6d81a73940fd0d inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a7bbdfbb5caad826f6e6d81a73940fd0d">getName</a> (<a class="el" href="struct_xs_string.html">XsString</a> &amp;filename) const </td></tr>
<tr class="memdesc:a7bbdfbb5caad826f6e6d81a73940fd0d inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieve the filename that was last successfully opened.  <a href="#a7bbdfbb5caad826f6e6d81a73940fd0d">More...</a><br /></td></tr>
<tr class="separator:a7bbdfbb5caad826f6e6d81a73940fd0d inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a396d5028db152401dd83cfe8f0b6977e inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a396d5028db152401dd83cfe8f0b6977e">getReadPosition</a> (void) const </td></tr>
<tr class="memdesc:a396d5028db152401dd83cfe8f0b6977e inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the current read position.  <a href="#a396d5028db152401dd83cfe8f0b6977e">More...</a><br /></td></tr>
<tr class="separator:a396d5028db152401dd83cfe8f0b6977e inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6ce051fb4db1dbace80bb0545b9cd343 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a6ce051fb4db1dbace80bb0545b9cd343">getWritePosition</a> (void) const </td></tr>
<tr class="memdesc:a6ce051fb4db1dbace80bb0545b9cd343 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the current write position.  <a href="#a6ce051fb4db1dbace80bb0545b9cd343">More...</a><br /></td></tr>
<tr class="separator:a6ce051fb4db1dbace80bb0545b9cd343 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad0d5e78791e017e06f8beaa6561bd844 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#ad0d5e78791e017e06f8beaa6561bd844">insertData</a> (<a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a> start, const <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;data)</td></tr>
<tr class="memdesc:ad0d5e78791e017e06f8beaa6561bd844 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Insert the given data into the file.  <a href="#ad0d5e78791e017e06f8beaa6561bd844">More...</a><br /></td></tr>
<tr class="separator:ad0d5e78791e017e06f8beaa6561bd844 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a905628de220b542bdfbf3692a55de428 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a905628de220b542bdfbf3692a55de428">isReadOnly</a> (void) const </td></tr>
<tr class="memdesc:a905628de220b542bdfbf3692a55de428 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return whether the file is read-only or not.  <a href="#a905628de220b542bdfbf3692a55de428">More...</a><br /></td></tr>
<tr class="separator:a905628de220b542bdfbf3692a55de428 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a041ed4c0878f91fa8c41a72aa7b3e802 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a041ed4c0878f91fa8c41a72aa7b3e802">open</a> (const <a class="el" href="struct_xs_string.html">XsString</a> &amp;filename, bool createNew, bool readOnly)</td></tr>
<tr class="memdesc:a041ed4c0878f91fa8c41a72aa7b3e802 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Open a file.  <a href="#a041ed4c0878f91fa8c41a72aa7b3e802">More...</a><br /></td></tr>
<tr class="separator:a041ed4c0878f91fa8c41a72aa7b3e802 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6e75151a26492f0fa9666edabc09d817 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a6e75151a26492f0fa9666edabc09d817">setReadPosition</a> (<a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a> pos)</td></tr>
<tr class="memdesc:a6e75151a26492f0fa9666edabc09d817 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the new absolute read position.  <a href="#a6e75151a26492f0fa9666edabc09d817">More...</a><br /></td></tr>
<tr class="separator:a6e75151a26492f0fa9666edabc09d817 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a115109da1f9f05a36222f00cd569cd52 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a115109da1f9f05a36222f00cd569cd52">setWritePosition</a> (<a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a> pos=-1)</td></tr>
<tr class="memdesc:a115109da1f9f05a36222f00cd569cd52 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the new absolute write position.  <a href="#a115109da1f9f05a36222f00cd569cd52">More...</a><br /></td></tr>
<tr class="separator:a115109da1f9f05a36222f00cd569cd52 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_types_struct_io_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_types_struct_io_interface')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="struct_io_interface.html">IoInterface</a></td></tr>
<tr class="memitem:a24230835a198e4af06866402ac41f22a inherit pub_types_struct_io_interface"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a24230835a198e4af06866402ac41f22a"></a>enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a24230835a198e4af06866402ac41f22a">PortOptions</a> { <br />
&#160;&#160;<b>PO_NoFlowControl</b> = 0, 
<b>PO_RtsCtsFlowControl</b> = (1 &lt;&lt; 0), 
<b>PO_DtrDsrFlowControl</b> = (1 &lt;&lt; 1), 
<b>PO_XonXoffFlowControl</b> = (1 &lt;&lt; 2), 
<br />
&#160;&#160;<b>PO_OneStopBit</b> = 0, 
<b>PO_TwoStopBits</b> = (1 &lt;&lt; 3), 
<b>PO_XsensDefaults</b> = (PO_NoFlowControl|PO_TwoStopBits)
<br />
 }<tr class="memdesc:a24230835a198e4af06866402ac41f22a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Options for flow control and stopbits which must be used when opening a port. <br /></td></tr>
</td></tr>
<tr class="separator:a24230835a198e4af06866402ac41f22a inherit pub_types_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_methods_class_stream_interface"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_class_stream_interface')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="class_stream_interface.html">StreamInterface</a></td></tr>
<tr class="memitem:ab40993736e0f3c472c19293355a26389 inherit pro_methods_class_stream_interface"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab40993736e0f3c472c19293355a26389"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_stream_interface.html#ab40993736e0f3c472c19293355a26389">StreamInterface</a> ()</td></tr>
<tr class="memdesc:ab40993736e0f3c472c19293355a26389 inherit pro_methods_class_stream_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a stream interface. <br /></td></tr>
<tr class="separator:ab40993736e0f3c472c19293355a26389 inherit pro_methods_class_stream_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_methods_struct_io_interface"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_struct_io_interface')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="struct_io_interface.html">IoInterface</a></td></tr>
<tr class="memitem:a0a4be67f0496efa12593cc69a802d784 inherit pro_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0a4be67f0496efa12593cc69a802d784"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a0a4be67f0496efa12593cc69a802d784">IoInterface</a> ()</td></tr>
<tr class="memdesc:a0a4be67f0496efa12593cc69a802d784 inherit pro_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor. <br /></td></tr>
<tr class="separator:a0a4be67f0496efa12593cc69a802d784 inherit pro_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>An <a class="el" href="struct_io_interface.html" title="An abstract IO interface. ">IoInterface</a> for dealing specifically with Xsens USB devices. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a86e9d5e41cb861313dfcc234b0909190"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> UsbInterface::closeUsb </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Close the USB communication port. </p>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the port was closed successfully </dd></dl>
<dl class="section note"><dt>Note</dt><dd>Linux:<br />
If a kernel driver was detached when communication with the device started, attach it again. No guarantee is given that udev will pick up on it though. </dd></dl>

</div>
</div>
<a class="anchor" id="aaf61c58b150bbf94cfe8c98768a7444a"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> UsbInterface::flushData </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Flush all data in the buffers to and from the device. </p>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the data was flushed successfully </dd></dl>

<p>Implements <a class="el" href="struct_io_interface.html#aac5cc2c3707b24cc15f9ab15914448fa">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="af99af474c041ab9b517b76655b7b608c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool UsbInterface::getRawIo </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Retrieves the state of the RAWIO mode of the USB interface. </p>
<dl class="section return"><dt>Returns</dt><dd>true if raw IO mode is enabled </dd></dl>
<dl class="section note"><dt>Note</dt><dd>Only applies to WinUSB implementations </dd></dl>

</div>
</div>
<a class="anchor" id="a6c6113f7c73248ff95524ce3d784b39d"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> UsbInterface::readData </td>
          <td>(</td>
          <td class="paramtype">XsSize&#160;</td>
          <td class="paramname"><em>maxLength</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;&#160;</td>
          <td class="paramname"><em>data</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Read data from the USB port and put it into the data buffer. </p>
<p>This function reads up to <em>maxLength</em> bytes from the port (non-blocking) and puts it into the <em>data</em> buffer. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">maxLength</td><td>The maximum amount of data read. </td></tr>
    <tr><td class="paramname">data</td><td>The buffer that will store the received data. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if no error occurred. It can be that no data is available and XRV_OK will be returned. Check data.size() for the number of bytes that were read. </dd></dl>

<p>Implements <a class="el" href="struct_io_interface.html#a33818cfaffd39a7e1382e465d26efc0a">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="aa532baddc5650010517434e37d61bae1"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> UsbInterface::readData </td>
          <td>(</td>
          <td class="paramtype">XsSize&#160;</td>
          <td class="paramname"><em>maxLength</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">XsSize *&#160;</td>
          <td class="paramname"><em>length</em> = <code>NULL</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Read data from the serial port and put it into the data buffer. </p>
<p>This function reads up to <em>maxLength</em> bytes from the USB port (non-blocking) and puts it into the <em>data</em> buffer. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">maxLength</td><td>The maximum number of bytes to read. </td></tr>
    <tr><td class="paramname">data</td><td>Pointer to a buffer that will store the received data. </td></tr>
    <tr><td class="paramname">length</td><td>The number of bytes placed into <code>data</code>. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if no error occurred. It can be that no data is available and XRV_OK will be returned. Check *length for the number of bytes that were read. </dd></dl>

</div>
</div>
<a class="anchor" id="aaa01d7bd28d4d7d2772097b2c86fd063"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void UsbInterface::setRawIo </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>enable</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sets the RAWIO mode of the USB interface. </p>
<dl class="section note"><dt>Note</dt><dd>Only applies to WinUSB implementations </dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">enable</td><td>: If true will enable RAW IO mode </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a78570ffcef7534e52d3f303a800a1acd"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> UsbInterface::setTimeout </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>ms</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Set the default timeout value to use in blocking operations. </p>
<p>This function sets the value of m_timeout. There is no infinity value. The value 0 means that the default value is used. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">ms</td><td>The desired timeout in milliseconds </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the timeout value was successfully updated </dd></dl>

<p>Implements <a class="el" href="class_stream_interface.html#ac787d6f9451b39e5315cc19993249861">StreamInterface</a>.</p>

</div>
</div>
<a class="anchor" id="ad86f450f4f49c9d4dcb9ecc3e3fb425a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> UsbInterface::waitForData </td>
          <td>(</td>
          <td class="paramtype">XsSize&#160;</td>
          <td class="paramname"><em>maxLength</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">XsSize *&#160;</td>
          <td class="paramname"><em>length</em> = <code>NULL</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Wait for data to arrive or a timeout to occur. </p>
<p>The function waits until <code>maxLength</code> data is available or until a timeout occurs. The function returns success if data is available or XsResultValue::TIMEOUT if a timeout occurred. A timeout value of 0 indicates that the default timeout stored in the class should be used. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">maxLength</td><td>The maximum number of bytes to wait for </td></tr>
    <tr><td class="paramname">data</td><td>A buffer that will be filled with the read data. It must be able to contain at least <em>maxLength</em> bytes. </td></tr>
    <tr><td class="paramname">length</td><td>An optional pointer to storage for the actual number of bytes read. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the requested data was read </dd></dl>

</div>
</div>
<a class="anchor" id="a305123c46c8c06e6d715d3e8e9bdc7b4"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> UsbInterface::writeData </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">XsSize *&#160;</td>
          <td class="paramname"><em>written</em> = <code>NULL</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Write the data to the USB port. </p>
<p>The function writes the given data to the connected USB port. The default timeout is respected in this operation. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">data</td><td>The data to be written </td></tr>
    <tr><td class="paramname">written</td><td>An optional pointer to storage for the actual number of bytes that were written </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the data was successfully written </dd></dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="class_usb_interface.html#aef40c902045c8bc9ec0d2f0d7145b4a6" title="Write the data to the USB port. ">writeData(const XsSize, const void *, XsSize*)</a> </dd></dl>

<p>Implements <a class="el" href="struct_io_interface.html#a8e8f067dac101d2ef49080956ad53970">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="aef40c902045c8bc9ec0d2f0d7145b4a6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> UsbInterface::writeData </td>
          <td>(</td>
          <td class="paramtype">XsSize&#160;</td>
          <td class="paramname"><em>length</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const void *&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">XsSize *&#160;</td>
          <td class="paramname"><em>written</em> = <code>NULL</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Write the data to the USB port. </p>
<p>The function writes the given data to the connected USB port. The default timeout is respected in this operation. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">length</td><td>The number of bytes to write. </td></tr>
    <tr><td class="paramname">data</td><td>A pointer to a memory buffer that contains the bytes to send </td></tr>
    <tr><td class="paramname">written</td><td>An optional pointer to storage for the actual number of bytes that were written </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the data was successfully written </dd></dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="class_usb_interface.html#a305123c46c8c06e6d715d3e8e9bdc7b4" title="Write the data to the USB port. ">writeData(const XsByteArray&amp;, XsSize*)</a> </dd></dl>

</div>
</div>
</div><!-- contents -->

<div class="tabs">&nbsp;</div>
<hr size="1" />
<address style="text-align: right;">
<small>Generated on Wed May 17 2017 for Xsens by <a href="http://www.doxygen.org/index.html">Doxygen</a> 1.8.11</small>
</address>
</body>
</html>
